#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 RoyalBlue
#property indicator_color2 Crimson
#property indicator_width1  2
#property indicator_width2  2
#property indicator_maximum 1
#property indicator_minimum 0

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    period          = 12;
extern double mod             = 1.2;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundFile       = "alert2.wav";

//
//
//
//
//

double up_buffer[];
double dn_buffer[];
double trend[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

int init() 
{
   IndicatorBuffers(3); 
   SetIndexBuffer(0,up_buffer);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dn_buffer);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trend);
   
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" Gann HiLo"); 
return(0);
}
int deinit() {   return (0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { up_buffer[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);               
                      up_buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",period,mod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
                      dn_buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",period,mod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);
               }
               return(0);
            }

   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      trend[i]=trend[i+1];
         if (Close[i]>((1.0 + mod / 10000.0)*iMA(Symbol(),0,period,0,MODE_SMA,PRICE_CLOSE,i+1))) trend[i]= 1;
         if (Close[i]<((1.0 - mod / 10000.0)*iMA(Symbol(),0,period,0,MODE_SMA,PRICE_CLOSE,i+1))) trend[i]=-1;
    
         up_buffer[i] = EMPTY_VALUE;
         dn_buffer[i] = EMPTY_VALUE;
         if (trend[i]== 1) up_buffer[i] = 1;
         if (trend[i]==-1) dn_buffer[i] = 1;
  }
  
  //
  //
  //
  //
  //
      
  if (alertsOn)
  {
    if (alertsOnCurrent)
         int whichBar = 0;
    else     whichBar = 1;
    if (trend[whichBar] != trend[whichBar+1])
    if (trend[whichBar] == 1)
          doAlert("Buy");
    else  doAlert("Sell"); 
  }      
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," GannHiLo-Histo ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," GannHiLo-Histo "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}